searchNodes=[{"doc":"Opens XLSX workbooks and reads its worksheets.Example{:ok, package} = XlsxReader.open(&quot;test.xlsx&quot;) XlsxReader.sheet_names(package) # [&quot;Sheet 1&quot;, &quot;Sheet 2&quot;, &quot;Sheet 3&quot;] {:ok, rows} = XlsxReader.sheet(package, &quot;Sheet 1&quot;) # [ # [&quot;Date&quot;, &quot;Temperature&quot;], # [~D[2019-11-01], 8.4], # [~D[2019-11-02], 7.5], # ... # ]Sheet contentsSheets are loaded on-demand by sheet/3 and sheets/2.The sheet contents is returned as a list of lists:[ [&quot;A1&quot;, &quot;B1&quot;, &quot;C1&quot; | _], [&quot;A2&quot;, &quot;B2&quot;, &quot;C2&quot; | _], [&quot;A3&quot;, &quot;B3&quot;, &quot;C3&quot; | _], | _ ]The behavior of the sheet parser can be customized for each individual sheet, see sheet/3.Cell typesThis library takes a best effort approach for determining cell types. In order of priority, the actual type of an XLSX cell value is determined using:basic cell properties (e.g. boolean)predefined known styles (e.g. default money/date formats)introspection of the custom format string associated with the cellCustom formats supported by defaultpercentagesISO 8601 date/time (y-m-d)US date/time (m/d/y)European date/time (d/m/y)Additional custom formats supportIf the spreadsheet you need to process contains some unusual cell formatting, you may provide hints to map format strings to a known cell type.The hints are given as a list of {matcher, type} tuples. The matcher is either a string or regex to match against the custom format string. The supported types are::string:number:percentage:date:time:date_time:unsupported (used for explicitly unsupported styles and formats)Example[ {&quot;mmm yy&quot;, :date}, {~r/mmm? yy hh:mm/, :date_time}, {&quot;[$CHF]0.00&quot;, :number} ]To find out what custom formats are in use in the workbook, you can inspect package.workbook.custom_formats:# num_fmt_id =&gt; format string %{ &quot;0&quot; =&gt; &quot;General&quot;, &quot;59&quot; =&gt; &quot;dd/mm/yyyy&quot;, &quot;60&quot; =&gt; &quot;dd/mm/yyyy hh:mm&quot;, &quot;61&quot; =&gt; &quot;hh:mm&quot;, &quot;62&quot; =&gt; &quot;0.0%&quot;, &quot;63&quot; =&gt; &quot;[$CHF]0.00&quot; }","ref":"XlsxReader.html","title":"XlsxReader","type":"module"},{"doc":"Loads all the sheets in the workbook concurrently.On success, returns {:ok, [{sheet_name, rows}, ...]}.When processing files with multiple sheets, async_sheets/3 is ~3x faster than sheets/2 but it comes with a caveat. async_sheets/3 uses Task.async_stream/3 under the hood and thus runs each concurrent task with a timeout. If you expect your dataset to be of a significant size, you may want to increase it from the default 10000ms (see &quot;Concurrency options&quot; below).If the order in which the sheets are returned is not relevant for your application, you can pass ordered: false (see &quot;Concurrency options&quot; below) for a modest speed gain.Filtering optionsSee sheets/2.Sheet optionsSee sheet/2.Concurrency optionsmax_concurrency - maximum number of tasks to run at the same time (default: System.schedulers_online/0)ordered - maintain order consistent with sheet_names/1 (default: true)timeout - maximum duration in milliseconds to process a sheet (default: 10_000)","ref":"XlsxReader.html#async_sheets/3","title":"XlsxReader.async_sheets/3","type":"function"},{"doc":"Opens an XLSX file located on the file system (default) or from memory.ExamplesOpening XLSX file on the file system{:ok, package} = XlsxReader.open(&quot;test.xlsx&quot;)Opening XLSX file from memoryblob = File.read!(&quot;test.xlsx&quot;) {:ok, package} = XlsxReader.open(blob, source: :binary)Optionssource: :path (on the file system, default) or :binary (in memory)supported_custom_formats: a list of {regex | string, type} tuples (see &quot;Additional custom formats support&quot;)","ref":"XlsxReader.html#open/2","title":"XlsxReader.open/2","type":"function"},{"doc":"Loads the sheet with the given name (see sheet_names/1)Optionstype_conversion - boolean (default: true)blank_value - placeholder value for empty cells (default: &quot;&quot;)empty_rows - include empty rows (default: true)number_type - type used for numeric conversion :Integer, Decimal or Float (default: Float)skip_row?: function callback that determines if a row should be skipped. Takes precedence over blank_value and empty_rows. Defaults to nil (keeping the behaviour of blank_value and empty_rows).cell_data_format: Controls the format of the cell data. Can be :value (default, returns the cell value only) or :cell (returns instances of XlsxReader.Cell).The Decimal type requires the decimal library.ExamplesSkipping rowsWhen using the skip_row? callback, rows are ignored in the parser which is more memory efficient.# Skip all rows for which all the values are either blank or &quot;-&quot; XlsxReader.sheet(package, &quot;Sheet1&quot;, skip_row?: fn row -&gt; Enum.all?(row, &amp; String.trim(&amp;1) in [&quot;&quot;, &quot;-&quot;]) end) # Skip all rows for which the first column contains the text &quot;disabled&quot; XlsxReader.sheet(package, &quot;Sheet1&quot;, skip_row?: fn [column | _] -&gt; column == &quot;disabled&quot; end)","ref":"XlsxReader.html#sheet/3","title":"XlsxReader.sheet/3","type":"function"},{"doc":"","ref":"XlsxReader.html#sheet_filter_option/2","title":"XlsxReader.sheet_filter_option/2","type":"function"},{"doc":"Lists the names of the sheets in the package's workbook","ref":"XlsxReader.html#sheet_names/1","title":"XlsxReader.sheet_names/1","type":"function"},{"doc":"Loads all the sheets in the workbook.On success, returns {:ok, [{sheet_name, rows}, ...]}.Filtering optionsonly - include the sheets whose name matches the filterexcept - exclude the sheets whose name matches the filterSheets can filtered by name using:a string (e.g. &quot;Exact Match&quot;)a regex (e.g. ~r/Sheet \d+/)a list of string and/or regexes (e.g. [&quot;Parameters&quot;, ~r/Sheet [12]/])Sheet optionsSee sheet/2.","ref":"XlsxReader.html#sheets/2","title":"XlsxReader.sheets/2","type":"function"},{"doc":"Error tuple with message describing the cause of the error","ref":"XlsxReader.html#t:error/0","title":"XlsxReader.error/0","type":"type"},{"doc":"List of cell values","ref":"XlsxReader.html#t:row/0","title":"XlsxReader.row/0","type":"type"},{"doc":"List of rows","ref":"XlsxReader.html#t:rows/0","title":"XlsxReader.rows/0","type":"type"},{"doc":"Sheet name","ref":"XlsxReader.html#t:sheet_name/0","title":"XlsxReader.sheet_name/0","type":"type"},{"doc":"Source for the XLSX file: file system (:path) or in-memory (:binary)","ref":"XlsxReader.html#t:source/0","title":"XlsxReader.source/0","type":"type"},{"doc":"Option to specify the XLSX file source","ref":"XlsxReader.html#t:source_option/0","title":"XlsxReader.source_option/0","type":"type"},{"doc":"Cell structure.This structure contains the information of a cell in a sheet.value - The value of the cellformula - The formula used in the cell, if anyref - The cell reference, like 'A1', 'B2', etc.This structure is used when the cell_data_format option is set to :cell.","ref":"XlsxReader.Cell.html","title":"XlsxReader.Cell","type":"module"},{"doc":"XLSX cell data","ref":"XlsxReader.Cell.html#t:t/0","title":"XlsxReader.Cell.t/0","type":"type"},{"doc":"Conversion of cell values to Elixir types.","ref":"XlsxReader.Conversion.html","title":"XlsxReader.Conversion","type":"module"},{"doc":"Returns the base date for the given date system.Examplesiex&gt; XlsxReader.Conversion.base_date(1900) ~D[1899-12-30] iex&gt; XlsxReader.Conversion.base_date(1904) ~D[1904-01-01] iex&gt; XlsxReader.Conversion.base_date(2019) :error","ref":"XlsxReader.Conversion.html#base_date/1","title":"XlsxReader.Conversion.base_date/1","type":"function"},{"doc":"Converts the string representation of a truth value into to a boolean.Cells with type attribute &quot;b&quot; store boolean values as a single digit: &quot;1&quot; or &quot;0&quot;.Examplesiex&gt; XlsxReader.Conversion.to_boolean(&quot;1&quot;) {:ok, true} iex&gt; XlsxReader.Conversion.to_boolean(&quot;0&quot;) {:ok, false} iex&gt; XlsxReader.Conversion.to_boolean(&quot;true&quot;) :error","ref":"XlsxReader.Conversion.html#to_boolean/1","title":"XlsxReader.Conversion.to_boolean/1","type":"function"},{"doc":"Converts a serial date into a Date.Examplesiex&gt; XlsxReader.Conversion.to_date(&quot;40396&quot;) {:ok, ~D[2010-08-06]} iex&gt; XlsxReader.Conversion.to_date(&quot;43783&quot;) {:ok, ~D[2019-11-14]} iex&gt; XlsxReader.Conversion.to_date(&quot;1&quot;, ~D[1999-12-31]) {:ok, ~D[2000-01-01]} iex&gt; XlsxReader.Conversion.to_date(&quot;-1&quot;, ~D[1999-12-31]) :error","ref":"XlsxReader.Conversion.html#to_date/2","title":"XlsxReader.Conversion.to_date/2","type":"function"},{"doc":"Converts a serial date to a NaiveDateTime.Examplesiex&gt; XlsxReader.Conversion.to_date_time(&quot;43783.0&quot;) {:ok, ~N[2019-11-14 00:00:00]} iex&gt; XlsxReader.Conversion.to_date_time(&quot;43783.760243055556&quot;) {:ok, ~N[2019-11-14 18:14:45]} iex&gt; XlsxReader.Conversion.to_date_time(&quot;0.4895833333333333&quot;) {:ok, ~N[1899-12-30 11:45:00]} iex&gt; XlsxReader.Conversion.to_date_time(&quot;1.760243055556&quot;, ~D[1999-12-31]) {:ok, ~N[2000-01-01 18:14:45]} iex&gt; XlsxReader.Conversion.to_date_time(&quot;-30.760243055556&quot;, ~D[1999-12-31]) :error","ref":"XlsxReader.Conversion.html#to_date_time/2","title":"XlsxReader.Conversion.to_date_time/2","type":"function"},{"doc":"Converts a string into an arbitrary precision decimal.Examplesiex&gt; XlsxReader.Conversion.to_decimal(&quot;123&quot;) {:ok, %Decimal{coef: 123, exp: 0, sign: 1}} iex&gt; XlsxReader.Conversion.to_decimal(&quot;-123.45&quot;) {:ok, %Decimal{coef: 12345, exp: -2, sign: -1}} iex&gt; XlsxReader.Conversion.to_decimal(&quot;0.12345e3&quot;) {:ok, %Decimal{coef: 12345, exp: -2, sign: 1}} iex&gt; XlsxReader.Conversion.to_decimal(&quot;0.12345E3&quot;) {:ok, %Decimal{coef: 12345, exp: -2, sign: 1}} iex&gt; XlsxReader.Conversion.to_decimal(&quot;bogus&quot;) :error","ref":"XlsxReader.Conversion.html#to_decimal/1","title":"XlsxReader.Conversion.to_decimal/1","type":"function"},{"doc":"Converts a string into a float.Examplesiex&gt; XlsxReader.Conversion.to_float(&quot;123&quot;) {:ok, 123.0} iex&gt; XlsxReader.Conversion.to_float(&quot;-123.45&quot;) {:ok, -123.45} iex&gt; XlsxReader.Conversion.to_float(&quot;0.12345e3&quot;) {:ok, 123.45} iex&gt; XlsxReader.Conversion.to_float(&quot;0.12345E3&quot;) {:ok, 123.45} iex&gt; XlsxReader.Conversion.to_float(&quot;bogus&quot;) :error","ref":"XlsxReader.Conversion.html#to_float/1","title":"XlsxReader.Conversion.to_float/1","type":"function"},{"doc":"Converts a string into an integer.Examplesiex&gt; XlsxReader.Conversion.to_integer(&quot;123&quot;) {:ok, 123} iex&gt; XlsxReader.Conversion.to_integer(&quot;-123&quot;) {:ok, -123} iex&gt; XlsxReader.Conversion.to_integer(&quot;123.45&quot;) :error iex&gt; XlsxReader.Conversion.to_integer(&quot;bogus&quot;) :error","ref":"XlsxReader.Conversion.html#to_integer/1","title":"XlsxReader.Conversion.to_integer/1","type":"function"},{"doc":"Converts a string into the given number type.Supported number types are: Integer, Float, String or Decimal (requires the decimal library)Examplesiex&gt; XlsxReader.Conversion.to_number(&quot;123&quot;, Integer) {:ok, 123} iex&gt; XlsxReader.Conversion.to_number(&quot;-123.45&quot;, Float) {:ok, -123.45} iex&gt; XlsxReader.Conversion.to_number(&quot;0.12345e3&quot;, Float) {:ok, 123.45} iex&gt; XlsxReader.Conversion.to_number(&quot;-123.45&quot;, Decimal) {:ok, %Decimal{coef: 12345, exp: -2, sign: -1}} iex&gt; XlsxReader.Conversion.to_number(&quot;0.12345E3&quot;, Decimal) {:ok, %Decimal{coef: 12345, exp: -2, sign: 1}} iex&gt; XlsxReader.Conversion.to_number(&quot;-123.45&quot;, String) {:ok, &quot;-123.45&quot;} iex&gt; XlsxReader.Conversion.to_number(&quot;0.12345e3&quot;, String) {:ok, &quot;0.12345e3&quot;} iex&gt; XlsxReader.Conversion.to_number(&quot;123.0&quot;, Integer) :error","ref":"XlsxReader.Conversion.html#to_number/2","title":"XlsxReader.Conversion.to_number/2","type":"function"},{"doc":"Date system identified by its reference year","ref":"XlsxReader.Conversion.html#t:date_system/0","title":"XlsxReader.Conversion.date_system/0","type":"type"},{"doc":"Supported number types identified by module name","ref":"XlsxReader.Conversion.html#t:number_type/0","title":"XlsxReader.Conversion.number_type/0","type":"type"},{"doc":"Supported number value types","ref":"XlsxReader.Conversion.html#t:number_value/0","title":"XlsxReader.Conversion.number_value/0","type":"type"},{"doc":"XSLX Package structure.This structure is initialized by XlsxReader.open/2 and is used to access the contents of the fileIt should not be manipulated directly.","ref":"XlsxReader.Package.html","title":"XlsxReader.Package","type":"module"},{"doc":"XLSX package","ref":"XlsxReader.Package.html#t:t/0","title":"XlsxReader.Package.t/0","type":"type"},{"doc":"Worksheet structure.This structure only contains the information useful to identify and retrieve the sheet actual data.name - name of the sheetrid - relationship ID used to retrieve the corresponding sheet in the archivesheet_id - unique identifier of the sheet withing the workbook (unused by XlsxReader)To access the sheet cells, see XlsxReader.sheet/3 and XlsxReader.sheets/2.","ref":"XlsxReader.Sheet.html","title":"XlsxReader.Sheet","type":"module"},{"doc":"XLSX worksheet metadata","ref":"XlsxReader.Sheet.html#t:t/0","title":"XlsxReader.Sheet.t/0","type":"type"},{"doc":"Workbook structure.sheets - list of sheet metadatarels - workbook relationshipsshared_strings - list of shared stringsstyle_types - List of types indexed by stylecustom_formats - Map of custom formats declared for this documentbase_date - base date for all serial dates in the workbook","ref":"XlsxReader.Workbook.html","title":"XlsxReader.Workbook","type":"module"},{"doc":"XLSX workbook","ref":"XlsxReader.Workbook.html#t:t/0","title":"XlsxReader.Workbook.t/0","type":"type"},{"doc":"XlsxReaderAn XLSX reader in Elixir.Features:Accepts XLSX data located on the file system or in memoryAutomatic type conversions (numbers, date &amp; times, booleans)Optional support for arbitrary precision decimal numbersStraightforward architecture: no ETS tables, no race-conditions, no manual resource managementThe docs can be found at https://hexdocs.pm/xlsx_reader.","ref":"readme.html","title":"XlsxReader","type":"extras"},{"doc":"Add xlsx_reader as a dependency in your mix.exs:def deps do [ {:xlsx_reader, &quot;~&gt; 0.8.0&quot;} ] endRun mix deps.get in your shell to fetch and compile XlsxReader.","ref":"readme.html#installation","title":"XlsxReader - Installation","type":"extras"},{"doc":"Loading from the file system {:ok, package} = XlsxReader.open(&quot;test.xlsx&quot;) XlsxReader.sheet_names(package) # [&quot;Sheet 1&quot;, &quot;Sheet 2&quot;, &quot;Sheet 3&quot;] {:ok, rows} = XlsxReader.sheet(package, &quot;Sheet 1&quot;) # [ # [&quot;Date&quot;, &quot;Temperature&quot;], # [~D[2019-11-01], 8.4], # [~D[2019-11-02], 7.5], # ... # ]Loading from memoryblob = File.read!(&quot;test.xlsx&quot;) {:ok, package} = XlsxReader.open(blob, source: :binary)Loading all sheets at once{:ok, sheets} = XlsxReader.sheets(package) # [ # {&quot;Sheet 1&quot;, [[&quot;Date&quot;, &quot;Temperature&quot;], ...]}, # {&quot;Sheet 2&quot;, [...]}, # ... # ]Loading sheets selectively{:ok, sheets} = XlsxReader.sheets(package, only: [&quot;Parameters&quot;, ~r/Sheet \\d+/], except: [&quot;Sheet 2&quot;]) # [ # {&quot;Parameters&quot;, [...]}, # {&quot;Sheet 1&quot;, [...]}, # {&quot;Sheet 3&quot;, [...]}, # {&quot;Sheet 4&quot;, [...]}, # ... # ]Loading all sheets at once concurrently{:ok, sheets} = XlsxReader.async_sheets(package) # [ # {&quot;Sheet 1&quot;, [[&quot;Date&quot;, &quot;Temperature&quot;], ...]}, # {&quot;Sheet 2&quot;, [...]}, # ... # ]Using arbitrary precision numbers{:ok, rows} = XlsxReader.sheet(package, &quot;Sheet 1&quot;, number_type: Decimal) # [ # [&quot;Date&quot;, &quot;Temperature&quot;], # [~D[2019-11-01], %Decimal{coef: 84, exp: -1, sign: 1}], # [~D[2019-11-02], %Decimal{coef: 75, exp: -1, sign: 1}], # ... # ]Access cell formulas{:ok, rows} = XlsxReader.sheet(package, &quot;Sheet 1&quot;, cell_data_format: :cell) # [ # [%Cell{value: 1234.0, formula: &quot;SUM(B1, B10)&quot;, ref: &quot;A1&quot;}, ...], # ... # ]","ref":"readme.html#examples","title":"XlsxReader - Examples","type":"extras"},{"doc":"Benchmarkingmix run benchmark/init.exs to create the benchmarking datasetmix run benchmark/run.exs to run the Benchee suite","ref":"readme.html#development","title":"XlsxReader - Development","type":"extras"},{"doc":"In order of appearance:Xavier Defrang (xavier)Darragh Enright (darraghenright)Patryk Woziński (patrykwozinski)Evaldo Bratti (evaldobratti)Zach Liss (ZachLiss)ParanojikJuan Barrios (03juan)Dylan Harness (dharness)","ref":"readme.html#contributors","title":"XlsxReader - Contributors","type":"extras"},{"doc":"Copyright 2020 Xavier DefrangLicensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"readme.html#license","title":"XlsxReader - License","type":"extras"}]